package com.liang.dao;

import com.liang.entity.StaActualexpenses;
import com.liang.entity.StaTravelexpenses;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * (StaActualexpenses)表数据库访问层
 *
 * @author makejava
 * @since 2023-05-30 11:38:53
 */
public interface StaActualexpensesDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaActualexpenses queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param staActualexpenses 查询条件
     * @param pageable          分页对象
     * @return 对象列表
     */
    List<StaActualexpenses> queryAllByLimit(StaActualexpenses staActualexpenses, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param staActualexpenses 查询条件
     * @return 总行数
     */
    long count(StaActualexpenses staActualexpenses);

    /**
     * 新增数据
     *
     * @param staActualexpenses 实例对象
     * @return 影响行数
     */
    int insert(StaActualexpenses staActualexpenses);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaActualexpenses> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<StaActualexpenses> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaActualexpenses> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StaActualexpenses> entities);

    /**
     * 修改数据
     *
     * @param staActualexpenses 实例对象
     * @return 影响行数
     */
    int update(StaActualexpenses staActualexpenses);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 通过主表删除数据
     *
     * @param zb
     * @return
     */
    int deleteByZb(Integer zb);

    /**
     * 批量删除差旅费
     *
     * @param zbList
     * @return
     */
    int batchDeleteByZb(List<Integer> zbList);

    /**
     * 获取差旅费列表
     *
     * @return
     */
    List<StaActualexpenses> getClfList(Integer zb);
}

